// Form1.cpp
// g++ Form1.cpp -oForm1.exe -mwindows -m64 -Os -s
// cl  Form1.cpp /O1 /Os /GS- /GR- /link TCLib.lib Kernel32.lib User32.lib Gdi32.lib 
// cl  Form1.cpp /O1 /Os /GS- /MT Kernel32.lib User32.lib gdi32.lib
//  5,120 Bytes x64, ansi, VC9,  TCLib Linkage
// 40,960 Bytes x64, ansi, VC9,  C Runtime Linkage
//  6,144 Bytes x64, ansi, VC15, TCLib Linkage
// 88,576 Bytes x64, ansi, VC15, C Runtime Linkage
#define TCLib
//#define Debug
#include <windows.h>
#ifdef TCLib
   #include "stdio.h"
   #include "string.h"
#else
   #include <cstdio>
   #include <string.h>
#endif
#include "Form1.h"
#ifdef Debug
   FILE* fp=NULL;
#endif


LRESULT fnWndProc_OnCreate(WndEventArgs& Wea)
{
 int   iCxScreen       = 0;
 int   iCyScreen       = 0;
 int   iCxEdge         = 0;
 int   iCyEdge         = 0;
 int   iCxBorder       = 0;
 int   iCyBorder       = 0;
 int   iCxFixedFrame   = 0;
 int   iCyFixedFrame   = 0;
 int   iCyCaption      = 0;
 int   iCxPaddedBorder = 0;
 HWND  hCtl            = NULL; 
 HFONT hFont           = NULL; 
 
 #ifdef Debug
 fp=fopen("Output.txt","w");
 fprintf(fp,"Entering fnWndProc_OnCreate()\n");
 #endif
 Wea.hIns=((LPCREATESTRUCT)Wea.lParam)->hInstance;
 iCxScreen       = GetSystemMetrics(SM_CXSCREEN);             // 1920
 iCyScreen       = GetSystemMetrics(SM_CYSCREEN);             // 1080
 iCxEdge         = GetSystemMetrics(SM_CXEDGE);               //    2 
 iCyEdge         = GetSystemMetrics(SM_CYEDGE);               //    2
 iCxBorder       = GetSystemMetrics(SM_CXBORDER);             //    1
 iCyBorder       = GetSystemMetrics(SM_CYBORDER);             //    1
 iCxFixedFrame   = GetSystemMetrics(SM_CXFIXEDFRAME);         //    3
 iCyFixedFrame   = GetSystemMetrics(SM_CYFIXEDFRAME);         //    3
 iCyCaption      = GetSystemMetrics(SM_CYCAPTION);            //   23
 iCxPaddedBorder = GetSystemMetrics(SM_CXPADDEDBORDER);       //    0
 #ifdef Debug
 fprintf(fp,"  iCxScreen       = %d\n",iCxScreen);
 fprintf(fp,"  iCyScreen       = %d\n",iCyScreen);
 fprintf(fp,"  iCxEdge         = %d\n",iCxEdge);
 fprintf(fp,"  iCyEdge         = %d\n",iCyEdge);
 fprintf(fp,"  iCxBorder       = %d\n",iCxBorder);
 fprintf(fp,"  iCyBorder       = %d\n",iCyBorder);
 fprintf(fp,"  iCxFixedFrame   = %d\n",iCxFixedFrame);
 fprintf(fp,"  iCyFixedFrame   = %d\n",iCyFixedFrame);
 fprintf(fp,"  iCyCaption      = %d\n",iCyCaption);
 fprintf(fp,"  iCxPaddedBorder = %d\n",iCxPaddedBorder);
 fprintf(fp,"  Wea.hWnd        = %Iu\n",Wea.hWnd);
 #endif
 MoveWindow(Wea.hWnd,(iCxScreen-246)/2,(iCyScreen-110)/2,246,110,FALSE);
 hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
 hCtl = CreateWindowEx(WS_EX_CLIENTEDGE,"Edit","",WS_CHILD|WS_VISIBLE|WS_TABSTOP|ES_AUTOHSCROLL,21,20,201,19,Wea.hWnd,(HMENU)IDC_TEXT,Wea.hIns,NULL);
 SendMessage(hCtl, (UINT)WM_SETFONT, (WPARAM)hFont, (LPARAM)0);
 SetFocus(hCtl);
 hCtl = CreateWindow("Button","OK", WS_CHILD|WS_VISIBLE|WS_TABSTOP,51,52,60,23,Wea.hWnd,(HMENU)IDC_OK,Wea.hIns,NULL);
 SendMessage(hCtl, (UINT)WM_SETFONT, (WPARAM)hFont, (LPARAM)0);
 hCtl = CreateWindow("Button","Cancel", WS_CHILD|WS_VISIBLE|WS_TABSTOP,126,52,60,23,Wea.hWnd,(HMENU)IDC_CANCEL,Wea.hIns,NULL);
 SendMessage(hCtl, (UINT)WM_SETFONT, (WPARAM)hFont, (LPARAM)0);
 #ifdef Debug
 fprintf(fp,"Leaving fnWndProc_OnCreate()\n\n");
 #endif
 
 return 0;
}


LRESULT fnWndProc_OnCommand(WndEventArgs& Wea)
{
 switch(LOWORD(Wea.wParam))
 {
   case IDC_OK:
     {    
        char szText[128];
        char szString[128];
        GetWindowText(GetDlgItem(Wea.hWnd,IDC_TEXT),szText,128);
        strcpy(szString,"Hello, ");
        strcat(szString,szText);
        strcat(szString,"!");
        MessageBox(Wea.hWnd,szString,"Greetings!",MB_OK);
        break;
     } 
   case IDC_CANCEL:
     {
        SendMessage(Wea.hWnd,WM_CLOSE,0,0);
        break;
     } 
 } 
  
 return 0;
}


LRESULT fnWndProc_OnDestroy(WndEventArgs& Wea)
{
 #ifdef Debug
 fprintf(fp,"Entering fnWndProc_OnDestroy()\n");
 fprintf(fp,"  Wea.hWnd = %Iu\n",Wea.hWnd);
 #endif
 PostQuitMessage(0);
 #ifdef Debug
 fprintf(fp,"Leaving fnWndProc_OnDestroy()\n");
 fclose(fp);
 #endif
 
 return 0;
}


LRESULT CALLBACK fnWndProc(HWND hwnd, unsigned int msg, WPARAM wParam, LPARAM lParam)
{
 WndEventArgs Wea;

 for(size_t i=0; i<dim(EventHandler); i++)
 {
     if(EventHandler[i].iMsg==msg)
     {
        Wea.hWnd=hwnd, Wea.lParam=lParam, Wea.wParam=wParam;
        return (*EventHandler[i].fnPtr)(Wea);
     }
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));
}


int WINAPI WinMain(HINSTANCE hIns, HINSTANCE hPrevIns, LPSTR lpszArgument, int iShow)
{
 char szClassName[]="Form1";
 WNDCLASSEX wc;
 HWND hWnd;
 MSG msg;

 wc.lpszClassName = szClassName;                     wc.lpfnWndProc = fnWndProc;
 wc.cbSize        = sizeof(WNDCLASSEX);              wc.style       = 0;
 wc.hIcon         = LoadIcon(NULL,IDI_APPLICATION);  wc.hInstance   = hIns;
 wc.hIconSm       = LoadIcon(NULL, IDI_APPLICATION); wc.hCursor     = LoadCursor(NULL,IDC_ARROW);
 wc.hbrBackground = (HBRUSH)COLOR_BTNSHADOW;         wc.cbWndExtra  = 0;
 wc.lpszMenuName  = NULL;                            wc.cbClsExtra  = 0;
 RegisterClassEx(&wc);
 hWnd=CreateWindowEx(0,szClassName,"What Is Your Name?",WS_CAPTION|WS_VISIBLE,0,0,0,0,HWND_DESKTOP,0,hIns,0);
 ShowWindow(hWnd,iShow);
 while(GetMessage(&msg, NULL, 0, 0))
 {
    if(!IsDialogMessage(hWnd, &msg))
    {
       TranslateMessage(&msg);
       DispatchMessage(&msg);
    }
 }
 
 return msg.wParam;
}
